(* Time-stamp: <modified the 21/02/2019 (at 11:00) by Erwan Jahier> *)

type t = Synchrone | Random1 | Random | Custom

let (random_list : 'a list -> 'a) = fun l ->
  assert (l <> []);
  List.nth l (Random.int (List.length l))

let (random1: 'a list list -> 'a list) =
  fun all -> 
   let al = List.map random_list all in
   let a = random_list al in
   [a]

let rec (random: 'a list list -> 'a list) =
  fun all ->
    assert (all <> []);
    let al = List.map random_list all in
    let al = List.filter (fun _ -> Random.bool ()) al in
    if al = [] then random all else al
   
let (synchrone: 'a list list -> 'a list) = fun all -> 
  let al = List.map random_list all in
  al
      
let (f: t -> 'a list list -> 'a list) = fun demon all ->
  match demon with
  | Synchrone  -> synchrone all
  | Random1 -> random1 all
  | Random -> random all
  | Custom -> assert false


      
