(* Time-stamp: <modified the 18/02/2019 (at 15:31) by Erwan Jahier> *)

type node_id = string
type node = {
  id: node_id;
  file: string;
  init: (string * string) list; 
}

type edge = node_id * node_id list

type t = node list

(* neighbor view from the sasa: in Algo.neighbor we hide the pid and
   compute the lenv *)
type neighbor = { 
  n_id:  string; 
  n_vars: (string * Algo.varT) list;
}

type node_info_t = (string, node) Hashtbl.t
val node_info : node_info_t 

type node_succ_t = (string, string list) Hashtbl.t
val node_succ : node_succ_t 

(** Parse a dot file 
XXX side effect: and fills the node_info and node_succ tables 
XXX good idea ?
*)
val read: string -> t
